<?php

require __DIR__."/vendor/autoload.php";
require __DIR__."/vendor/zeedhi/framework/bootstrap.php";
require __DIR__ . "/vendor/teknisa/libraries/scripts/bootstrap.php";

date_default_timezone_set('America/Sao_Paulo');

$instanceManager = \Zeedhi\Framework\DependencyInjection\InstanceManager::getInstance();

$routes = array();
$routes[] = __DIR__ . '/vendor/teknisa/libraries/libRoutes.json';
$routes[] = __DIR__ . '/config/routes.json';

$instanceManager->loadFromFile(__DIR__.'/config/db.xml');
$instanceManager->loadFromFile(__DIR__.'/config/report.xml');
$instanceManager->loadFromFile(__DIR__.'/config/parameters.xml');
$instanceManager->loadFromFile(__DIR__.'/config/environment.xml');
$instanceManager->loadFromFile(__DIR__.'/config/services.xml');
$instanceManager->loadFromFile(__DIR__.'/config/controllers.xml');

$container = $instanceManager->getContainer();

if ($container->hasParameter('use_zhu_acl') && $container->getParameter('use_zhu_acl') == 'true'){
    $acl = __DIR__ . '/../modules/acl/backend/config/acl.xml';
    
    if(realpath($acl)) {
        $instanceManager->loadFromFile($acl);
    }
    require __DIR__ . "/vendor/zeedhi/zhuaclbackend/service/bootstrap.php";
    $routes[] = __DIR__ . "/vendor/zeedhi/zhuaclbackend/config/routes.json";
}

if ($container->hasParameter('use_zhu_update') && $container->getParameter('use_zhu_update') == 'true') {
    $zhu = __DIR__ . '/../modules/acl/backend/config/zhuUpdate.xml';

    if(realpath($zhu)){
        $instanceManager->loadFromFile($zhu);
    }
}

$instanceManager->registerService('routeParser', new \Zeedhi\Framework\Routing\Parsers\JSONFormat($routes));

$instanceManager->compile();


